﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FirstMvcApp.Models;

namespace FirstMvcApp.Controllers
{
    public class EmployeeController : Controller
    {
        

        //
        // GET: /Employee/

        public ActionResult Index()
        {
            return View(CreateData());
        }

        //
        // GET: /Employee/Details/5

        public ActionResult EmployeeDetail(int id)
        {
            var employee =  GetDetail(id.ToString());
            return View(employee);
        }

        // 
        // GET: Method to handle jquery calls

        public ActionResult EmployeeDetailJson(int id)
        {
            var employee = GetDetail(id.ToString());
            return Json(employee, JsonRequestBehavior.AllowGet);
        }

        //
        // GET: /Employee/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Employee/Create

        [HttpPost]
        public ActionResult Create(FormCollection collection)
        {
            try
            {
                // TODO: Add insert logic here

                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }
        
        //
        // GET: /Employee/Edit/5
 
        public ActionResult Edit(int id)
        {
            return View();
        }

        //
        // POST: /Employee/Edit/5

        [HttpPost]
        public ActionResult EmployeeDetail(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add update logic here
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        //
        // GET: /Employee/Delete/5
 
        public ActionResult Delete(int id)
        {
            return View();
        }

        //
        // POST: /Employee/Delete/5

        [HttpPost]
        public ActionResult Delete(int id, FormCollection collection)
        {
            try
            {
                // TODO: Add delete logic here
 
                return RedirectToAction("Index");
            }
            catch
            {
                return View();
            }
        }

        public ActionResult JsonResult()
        {
            var employees = CreateData();
            return Json(employees, JsonRequestBehavior.AllowGet);
        }

        private IList<EmployeeModel> CreateData()
        {
            List<EmployeeModel> employees = new List<EmployeeModel>();
            employees.Add(new EmployeeModel() { 
                EmployeeId = "1", 
                EmployeeName = "XYZ", 
                EmployeeAddress = "Newark,CA",
                EmployeeEmail="xyz@rms.com",
                EmployeeTelephone="(123) 123-1234",
            EmployeeJoinDate=DateTime.Now.Date});

            employees.Add(new EmployeeModel() { 
                EmployeeId = "2", 
                EmployeeName = "ABC", 
                EmployeeAddress = "Fremont,CA", 
                EmployeeEmail = "abc@rms.com",
                EmployeeTelephone = "(123) 123-1234",
                EmployeeJoinDate = DateTime.Now.Date
            });

            employees.Add(new EmployeeModel() { 
                EmployeeId = "3", 
                EmployeeName = "PQR", 
                EmployeeAddress = "San Jose,CA", 
                EmployeeEmail = "pqr@rms.com",
                EmployeeTelephone = "(123) 123-1234",
                EmployeeJoinDate = DateTime.Now.Date
            });
            employees.Add(new EmployeeModel()
            {
                EmployeeId = "4",
                EmployeeName = "EFG",
                EmployeeAddress = "Charlotte,NC",
                EmployeeEmail = "efg@rms.com",
                EmployeeTelephone = "(800) 000-1234",
                EmployeeJoinDate = DateTime.Now.Date
            });
            return employees;
        }

        private EmployeeModel GetDetail(string id)
        {
            IList<EmployeeModel> employees = CreateData();
            return employees.Single(p=>p.EmployeeId.Equals(id));

        }

        public string TestAjax(string textBox1)
        {
            if (textBox1 != "Enter text")
            {
                return "You entered: \"" + textBox1.ToString() + "\" at " +
                    DateTime.Now.ToLongTimeString();
            }

            return String.Empty;
        }


        public ActionResult TreeView()
        {
            return View("TreeView");
        }

        public ActionResult Returndata()
        {
            return (Json(new { Status = "From Server" }, JsonRequestBehavior.AllowGet));
        }
    }
}
